#include "gen_tu.hpp"
#include "generate.hpp"

#include <iostream>


namespace beaker {
namespace jvm {

using namespace lang_tu;

/// \todo The prelude should actually be generated by functions.
///
/// \tood Support generating structured class names (e.g., foo/Bar). This
/// should be based on a module declaration within the TU.
void
generate_decl(codegen& gen, const tu_decl* d)
{
  /// Create a new global class generator.
  file fgen(gen);

  // FIXME: Call this something other than Main?
  fgen.outs() << ".class public Main\n";
  fgen.outs() << ".super java/lang/Object\n\n";
  
  // Generates the constructor for the main class.
  fgen.outs() << ".method public <init>()V\n";
  fgen.outs() << "  aload_0\n";
  fgen.outs() << "  invokespecial java/lang/Object/<init>()V\n";
  fgen.outs() << "  return\n";
  fgen.outs() << ".end method\n\n";

  // Generate the call to the main program. Note that this won't compile
  // if tu doesn't include a call to main.
  fgen.outs() << ".method public static main([Ljava/lang/String;)V\n";
  fgen.outs() << "  .limit stack 1\n";
  fgen.outs() << "  .limit locals 1\n";
  fgen.outs() << "  invokestatic Main/__main()I\n";
  fgen.outs() << "  return\n";
  fgen.outs() << ".end method\n\n";

  for (const decl* tld : d->get_declarations())
    generate(fgen, tld);
}

} // namespace jvm
} // namespace beaker
